#ifndef _H_78EDB4745326C2A033D77B118A2969E0_CanBusData_DCPS_H_
#define _H_78EDB4745326C2A033D77B118A2969E0_CanBusData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "CanBusData_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class CanBusData_TypeSupportInterface;

            typedef CanBusData_TypeSupportInterface * CanBusData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < CanBusData_TypeSupportInterface> CanBusData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < CanBusData_TypeSupportInterface> CanBusData_TypeSupportInterface_out;


            class CanBusData_DataWriter;

            typedef CanBusData_DataWriter * CanBusData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < CanBusData_DataWriter> CanBusData_DataWriter_var;
            typedef DDS_DCPSInterface_out < CanBusData_DataWriter> CanBusData_DataWriter_out;


            class CanBusData_DataReader;

            typedef CanBusData_DataReader * CanBusData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < CanBusData_DataReader> CanBusData_DataReader_var;
            typedef DDS_DCPSInterface_out < CanBusData_DataReader> CanBusData_DataReader_out;


            class CanBusData_DataReaderView;

            typedef CanBusData_DataReaderView * CanBusData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < CanBusData_DataReaderView> CanBusData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < CanBusData_DataReaderView> CanBusData_DataReaderView_out;

            struct CanBusData_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < CanBusData_, struct CanBusData_Seq_uniq_> CanBusData_Seq;
            typedef DDS_DCPSSequence_var < CanBusData_Seq> CanBusData_Seq_var;
            typedef DDS_DCPSSequence_out < CanBusData_Seq> CanBusData_Seq_out;

            class  CanBusData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef CanBusData_TypeSupportInterface_ptr _ptr_type;
                typedef CanBusData_TypeSupportInterface_var _var_type;

                static CanBusData_TypeSupportInterface_ptr _duplicate (CanBusData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CanBusData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static CanBusData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CanBusData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                CanBusData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                CanBusData_TypeSupportInterface () {};
                ~CanBusData_TypeSupportInterface () {};
            private:
                CanBusData_TypeSupportInterface (const CanBusData_TypeSupportInterface &);
                CanBusData_TypeSupportInterface & operator = (const CanBusData_TypeSupportInterface &);
            };

            class  CanBusData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef CanBusData_DataWriter_ptr _ptr_type;
                typedef CanBusData_DataWriter_var _var_type;

                static CanBusData_DataWriter_ptr _duplicate (CanBusData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CanBusData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static CanBusData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CanBusData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                CanBusData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const CanBusData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const CanBusData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const CanBusData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const CanBusData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const CanBusData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const CanBusData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const CanBusData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const CanBusData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const CanBusData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const CanBusData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (CanBusData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CanBusData_& instance_data) = 0;

            protected:
                CanBusData_DataWriter () {};
                ~CanBusData_DataWriter () {};
            private:
                CanBusData_DataWriter (const CanBusData_DataWriter &);
                CanBusData_DataWriter & operator = (const CanBusData_DataWriter &);
            };

            class  CanBusData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef CanBusData_DataReader_ptr _ptr_type;
                typedef CanBusData_DataReader_var _var_type;

                static CanBusData_DataReader_ptr _duplicate (CanBusData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CanBusData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static CanBusData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CanBusData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                CanBusData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CanBusData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CanBusData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CanBusData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CanBusData_& instance) = 0;

            protected:
                CanBusData_DataReader () {};
                ~CanBusData_DataReader () {};
            private:
                CanBusData_DataReader (const CanBusData_DataReader &);
                CanBusData_DataReader & operator = (const CanBusData_DataReader &);
            };

            class  CanBusData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef CanBusData_DataReaderView_ptr _ptr_type;
                typedef CanBusData_DataReaderView_var _var_type;

                static CanBusData_DataReaderView_ptr _duplicate (CanBusData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static CanBusData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static CanBusData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static CanBusData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                CanBusData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (CanBusData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (CanBusData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (CanBusData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (CanBusData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const CanBusData_& instance) = 0;

            protected:
                CanBusData_DataReaderView () {};
                ~CanBusData_DataReaderView () {};
            private:
                CanBusData_DataReaderView (const CanBusData_DataReaderView &);
                CanBusData_DataReaderView & operator = (const CanBusData_DataReaderView &);
            };
        }

    }

}

#endif
