#ifndef _H_25E5373B3BB5087E891CECAF69619FA0_DetectedRadarObjectArray_DCPS_H_
#define _H_25E5373B3BB5087E891CECAF69619FA0_DetectedRadarObjectArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DetectedRadarObjectArray_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DetectedRadarObjectArray_TypeSupportInterface;

            typedef DetectedRadarObjectArray_TypeSupportInterface * DetectedRadarObjectArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObjectArray_TypeSupportInterface> DetectedRadarObjectArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObjectArray_TypeSupportInterface> DetectedRadarObjectArray_TypeSupportInterface_out;


            class DetectedRadarObjectArray_DataWriter;

            typedef DetectedRadarObjectArray_DataWriter * DetectedRadarObjectArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObjectArray_DataWriter> DetectedRadarObjectArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObjectArray_DataWriter> DetectedRadarObjectArray_DataWriter_out;


            class DetectedRadarObjectArray_DataReader;

            typedef DetectedRadarObjectArray_DataReader * DetectedRadarObjectArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObjectArray_DataReader> DetectedRadarObjectArray_DataReader_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObjectArray_DataReader> DetectedRadarObjectArray_DataReader_out;


            class DetectedRadarObjectArray_DataReaderView;

            typedef DetectedRadarObjectArray_DataReaderView * DetectedRadarObjectArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DetectedRadarObjectArray_DataReaderView> DetectedRadarObjectArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DetectedRadarObjectArray_DataReaderView> DetectedRadarObjectArray_DataReaderView_out;

            struct DetectedRadarObjectArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DetectedRadarObjectArray_, struct DetectedRadarObjectArray_Seq_uniq_> DetectedRadarObjectArray_Seq;
            typedef DDS_DCPSSequence_var < DetectedRadarObjectArray_Seq> DetectedRadarObjectArray_Seq_var;
            typedef DDS_DCPSSequence_out < DetectedRadarObjectArray_Seq> DetectedRadarObjectArray_Seq_out;

            class  DetectedRadarObjectArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DetectedRadarObjectArray_TypeSupportInterface_ptr _ptr_type;
                typedef DetectedRadarObjectArray_TypeSupportInterface_var _var_type;

                static DetectedRadarObjectArray_TypeSupportInterface_ptr _duplicate (DetectedRadarObjectArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObjectArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObjectArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DetectedRadarObjectArray_TypeSupportInterface () {};
                ~DetectedRadarObjectArray_TypeSupportInterface () {};
            private:
                DetectedRadarObjectArray_TypeSupportInterface (const DetectedRadarObjectArray_TypeSupportInterface &);
                DetectedRadarObjectArray_TypeSupportInterface & operator = (const DetectedRadarObjectArray_TypeSupportInterface &);
            };

            class  DetectedRadarObjectArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DetectedRadarObjectArray_DataWriter_ptr _ptr_type;
                typedef DetectedRadarObjectArray_DataWriter_var _var_type;

                static DetectedRadarObjectArray_DataWriter_ptr _duplicate (DetectedRadarObjectArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObjectArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObjectArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DetectedRadarObjectArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DetectedRadarObjectArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DetectedRadarObjectArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObjectArray_& instance_data) = 0;

            protected:
                DetectedRadarObjectArray_DataWriter () {};
                ~DetectedRadarObjectArray_DataWriter () {};
            private:
                DetectedRadarObjectArray_DataWriter (const DetectedRadarObjectArray_DataWriter &);
                DetectedRadarObjectArray_DataWriter & operator = (const DetectedRadarObjectArray_DataWriter &);
            };

            class  DetectedRadarObjectArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DetectedRadarObjectArray_DataReader_ptr _ptr_type;
                typedef DetectedRadarObjectArray_DataReader_var _var_type;

                static DetectedRadarObjectArray_DataReader_ptr _duplicate (DetectedRadarObjectArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObjectArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObjectArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedRadarObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedRadarObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObjectArray_& instance) = 0;

            protected:
                DetectedRadarObjectArray_DataReader () {};
                ~DetectedRadarObjectArray_DataReader () {};
            private:
                DetectedRadarObjectArray_DataReader (const DetectedRadarObjectArray_DataReader &);
                DetectedRadarObjectArray_DataReader & operator = (const DetectedRadarObjectArray_DataReader &);
            };

            class  DetectedRadarObjectArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DetectedRadarObjectArray_DataReaderView_ptr _ptr_type;
                typedef DetectedRadarObjectArray_DataReaderView_var _var_type;

                static DetectedRadarObjectArray_DataReaderView_ptr _duplicate (DetectedRadarObjectArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DetectedRadarObjectArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DetectedRadarObjectArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DetectedRadarObjectArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DetectedRadarObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DetectedRadarObjectArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DetectedRadarObjectArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DetectedRadarObjectArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DetectedRadarObjectArray_& instance) = 0;

            protected:
                DetectedRadarObjectArray_DataReaderView () {};
                ~DetectedRadarObjectArray_DataReaderView () {};
            private:
                DetectedRadarObjectArray_DataReaderView (const DetectedRadarObjectArray_DataReaderView &);
                DetectedRadarObjectArray_DataReaderView & operator = (const DetectedRadarObjectArray_DataReaderView &);
            };
        }

    }

}

#endif
