#ifndef _H_D62B9CF702A7051CD94C85C68703D842_Detection2D__H_
#define _H_D62B9CF702A7051CD94C85C68703D842_Detection2D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "lgsvl_msgs/msg/dds_opensplice/BoundingBox2D_.h"
#include "geometry_msgs/msg/dds_opensplice/Twist_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Detection2D_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::ULong id_;
                ::DDS::String_mgr label_;
                ::DDS::Float score_;
                ::lgsvl_msgs::msg::dds_::BoundingBox2D_ bbox_;
                ::geometry_msgs::msg::dds_::Twist_ velocity_;
            };

            typedef DDS_DCPSStruct_var<Detection2D_> Detection2D__var;
            typedef DDS_DCPSStruct_out < Detection2D_> Detection2D__out;

        }

    }

}

#endif /* _H_D62B9CF702A7051CD94C85C68703D842_Detection2D__H_ */
