#ifndef _H_1A0812D273DE53AC970AAA28B471EBF0_Detection3D__H_
#define _H_1A0812D273DE53AC970AAA28B471EBF0_Detection3D__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "lgsvl_msgs/msg/dds_opensplice/BoundingBox3D_.h"
#include "geometry_msgs/msg/dds_opensplice/Twist_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  Detection3D_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::ULong id_;
                ::DDS::String_mgr label_;
                ::DDS::Float score_;
                ::lgsvl_msgs::msg::dds_::BoundingBox3D_ bbox_;
                ::geometry_msgs::msg::dds_::Twist_ velocity_;
            };

            typedef DDS_DCPSStruct_var<Detection3D_> Detection3D__var;
            typedef DDS_DCPSStruct_out < Detection3D_> Detection3D__out;

        }

    }

}

#endif /* _H_1A0812D273DE53AC970AAA28B471EBF0_Detection3D__H_ */
