#ifndef _H_41E501FD91D3E0B82F1B57AFCC8B8AA4_VehicleControlData_DCPS_H_
#define _H_41E501FD91D3E0B82F1B57AFCC8B8AA4_VehicleControlData_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleControlData_.h"


namespace lgsvl_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleControlData_TypeSupportInterface;

            typedef VehicleControlData_TypeSupportInterface * VehicleControlData_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlData_TypeSupportInterface> VehicleControlData_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleControlData_TypeSupportInterface> VehicleControlData_TypeSupportInterface_out;


            class VehicleControlData_DataWriter;

            typedef VehicleControlData_DataWriter * VehicleControlData_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlData_DataWriter> VehicleControlData_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleControlData_DataWriter> VehicleControlData_DataWriter_out;


            class VehicleControlData_DataReader;

            typedef VehicleControlData_DataReader * VehicleControlData_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlData_DataReader> VehicleControlData_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleControlData_DataReader> VehicleControlData_DataReader_out;


            class VehicleControlData_DataReaderView;

            typedef VehicleControlData_DataReaderView * VehicleControlData_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlData_DataReaderView> VehicleControlData_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleControlData_DataReaderView> VehicleControlData_DataReaderView_out;

            struct VehicleControlData_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleControlData_, struct VehicleControlData_Seq_uniq_> VehicleControlData_Seq;
            typedef DDS_DCPSSequence_var < VehicleControlData_Seq> VehicleControlData_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleControlData_Seq> VehicleControlData_Seq_out;

            class  VehicleControlData_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleControlData_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleControlData_TypeSupportInterface_var _var_type;

                static VehicleControlData_TypeSupportInterface_ptr _duplicate (VehicleControlData_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlData_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlData_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlData_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlData_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleControlData_TypeSupportInterface () {};
                ~VehicleControlData_TypeSupportInterface () {};
            private:
                VehicleControlData_TypeSupportInterface (const VehicleControlData_TypeSupportInterface &);
                VehicleControlData_TypeSupportInterface & operator = (const VehicleControlData_TypeSupportInterface &);
            };

            class  VehicleControlData_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleControlData_DataWriter_ptr _ptr_type;
                typedef VehicleControlData_DataWriter_var _var_type;

                static VehicleControlData_DataWriter_ptr _duplicate (VehicleControlData_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlData_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlData_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleControlData_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleControlData_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleControlData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleControlData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleControlData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleControlData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleControlData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleControlData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleControlData_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleControlData_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleControlData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlData_& instance_data) = 0;

            protected:
                VehicleControlData_DataWriter () {};
                ~VehicleControlData_DataWriter () {};
            private:
                VehicleControlData_DataWriter (const VehicleControlData_DataWriter &);
                VehicleControlData_DataWriter & operator = (const VehicleControlData_DataWriter &);
            };

            class  VehicleControlData_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleControlData_DataReader_ptr _ptr_type;
                typedef VehicleControlData_DataReader_var _var_type;

                static VehicleControlData_DataReader_ptr _duplicate (VehicleControlData_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlData_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlData_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControlData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControlData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControlData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlData_& instance) = 0;

            protected:
                VehicleControlData_DataReader () {};
                ~VehicleControlData_DataReader () {};
            private:
                VehicleControlData_DataReader (const VehicleControlData_DataReader &);
                VehicleControlData_DataReader & operator = (const VehicleControlData_DataReader &);
            };

            class  VehicleControlData_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleControlData_DataReaderView_ptr _ptr_type;
                typedef VehicleControlData_DataReaderView_var _var_type;

                static VehicleControlData_DataReaderView_ptr _duplicate (VehicleControlData_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlData_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlData_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlData_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControlData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControlData_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControlData_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControlData_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlData_& instance) = 0;

            protected:
                VehicleControlData_DataReaderView () {};
                ~VehicleControlData_DataReaderView () {};
            private:
                VehicleControlData_DataReaderView (const VehicleControlData_DataReaderView &);
                VehicleControlData_DataReaderView & operator = (const VehicleControlData_DataReaderView &);
            };
        }

    }

}

#endif
